import { HTMLProps, IndexKey } from 'web-utility';
export type DataObject = Record<string, any>;
export declare class VNode {
    key?: IndexKey;
    ref?: (node: Node) => any;
    text?: string;
    selector?: string;
    tagName?: string;
    is?: string;
    props?: DataObject;
    style?: HTMLProps<HTMLElement>['style'];
    children?: VNode[];
    node?: Node;
    constructor(meta: VNode);
    static propsMap: Partial<Record<keyof HTMLProps<HTMLLabelElement>, string>>;
    static attrsMap: Record<string, keyof HTMLProps<HTMLLabelElement>>;
    static fromDOM(node: Node): VNode;
}
declare global {
    /**
     * @see {@link https://www.typescriptlang.org/docs/handbook/jsx.html}
     */
    namespace JSX {
        type Element = VNode;
        type IntrinsicElements = {
            [tagName in keyof HTMLElementTagNameMap]: HTMLProps<HTMLElementTagNameMap[tagName]> & Pick<VNode, 'is' | 'key' | 'ref'>;
        };
    }
}
